## mingw-w64-sad-0.4.32-1.src.tar.zst

=== Makefile ===
MAKEFLAGS += --jobs
MAKEFLAGS += --no-builtin-rules
MAKEFLAGS += --warn-undefined-variables
SHELL := bash
.DELETE_ON_ERROR:
.ONESHELL:
.SHELLFLAGS := --norc --noprofile -Eeuo pipefail -O dotglob -O nullglob -O failglob -O globstar -c

.DEFAULT_GOAL := dev

.PHONY: clean clobber lint mypy clippy deps build release ci test

OS ?=

ifeq ($(OS),Windows_NT)
VENV := Scripts
else
VENV := bin
endif

clean:
	shopt -u failglob
	rm -v -rf -- artifacts/*.{zip,deb} .mypy_cache/ target/ temp/

clobber: clean
	rm -v -rf -- .venv/

.venv/$(VENV)/pip:
	python -m venv -- .venv

.venv/$(VENV)/mypy: .venv/$(VENV)/pip
	'$<' install --upgrade --requirement requirements.txt -- mypy types-PyYAML types-toml types-Jinja2

mypy: .venv/$(VENV)/mypy
	'$<' -- .

dev:
	cargo build

clippy:
	cargo clippy --all-targets --all-features

lint: mypy clippy

deps: .venv/$(VENV)/mypy
	.venv/$(VENV)/python ./build.py deps

build: lint test
	.venv/$(VENV)/python ./build.py build

release: .venv/$(VENV)/mypy
	.venv/$(VENV)/python ./build.py buildr -- "$$TRIPLE"

ci: .venv/$(VENV)/mypy
	.venv/$(VENV)/python ./ci/release.py

test:
	cargo test --locked

=== PKGBUILD ===
# Maintainer: Maksim Bondarenkov <maksapple2306@gmail.com>

_realname=sad
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=0.4.32
pkgrel=1
pkgdesc="Space Age seD (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64')
url='https://github.com/ms-jpq/sad'
license=('spdx:MIT')
makedepends=("${MINGW_PACKAGE_PREFIX}-rust" "${MINGW_PACKAGE_PREFIX}-python")
optdepends=("${MINGW_PACKAGE_PREFIX}-fzf: for tui usage"
            "${MINGW_PACKAGE_PREFIX}-delta: for diff colourizer")
source=("${url}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('a67902b9edb287861668ee3e39482c17b41c60e244ece62b3f8016250286294f')

prepare() {
  cd "${_realname}-${pkgver}"

  cargo fetch --locked --target "$(rustc -vV | sed -n 's/host: //p')"
}

build() {
  cd "${_realname}-${pkgver}"

  cargo build --release --frozen
}

check() {
  cd "${_realname}-${pkgver}"

  cargo test --release --frozen
}

package() {
  cd "${_realname}-${pkgver}"

  cargo install \
    --offline \
    --no-track \
    --frozen \
    --path . \
    --root "${pkgdir}${MINGW_PREFIX}"

  install -Dm644 LICENSE "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
